const byte mynode = 1; // Node (1 to 255)
const bool outputdigital = false; // Output example to digital pins

const int maximum=50;
int analogarray[maximum]; // Array of analog values
byte digitalarray[maximum]; // Array of digital values
byte frame[50];
 
void setup() { 
  if (outputdigital==true) {  for (byte i=0;i<7;i++) {   pinMode(i, INPUT);  } for (byte i=7;i<14;i++) {   pinMode(i, OUTPUT);  }  }
 //Initialize serial and wait for port to open:
  Serial.begin(9600); 
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB
  }
} 
 
 
void loop() {
 ////code:
 
 
 /////communication simple MODBUS RTU:
 byte node, function, qtde, i, j;
 word address, value;
 unsigned int crc1, crccalculated;
        if (Serial.available() >= 8) {
                 // get bytes:
                 for (i=0;i<4;i++) {  frame[i]=Serial.read(); }
                 node = frame[0]; function = frame[1]; address = frame[2]*256+frame[3]; 
                 if (function == 16) { 
                    for (i=4;i<=6;i++) {  frame[i]=Serial.read(); }
                    qtde = frame[4]*256+frame[5]; 
                    
                    j=7; for (i=0;i<qtde;i++) {  frame[j]=Serial.read();j=j+1;frame[j]=Serial.read();j=j+1; }
                    frame[j]=Serial.read(); frame[j+1]=Serial.read();
                    crc1 = frame[j]*256+frame[j+1]; crccalculated = CRC16(7+qtde*2);
                 } else {
                    for (i=0;i<4;i++) {  frame[i+4]=Serial.read(); }
                    value = frame[4]*256+frame[5]; crc1 = frame[6]*256+frame[7];  crccalculated = CRC16(6);
                  }
                 //// send bytes
                 if ((node == mynode) && (crccalculated==crc1)) {
                  if ((function >= 1 )&&(function <= 4)) {
                    if (value<=255) { qtde = value; } else { qtde = 1; }; if (qtde>20) {qtde=20;}
                    if ((address+qtde)>maximum) { qtde=maximum-address; }
                    frame[0]=mynode; frame[1]=function; 
                    j=3;
                    if (function == 1) {
                       frame[2]=qtde; for (i=0;i<qtde;i++) { value = digitalarray[address+i]; frame[j] = value; j=j+1; }
                       crc1 = CRC16(3+qtde);
                    } else
                    if (function == 2) {
                       frame[2]=qtde; for (i=0;i<qtde;i++) { value = digitalRead(address+i); frame[j] = value; j=j+1; }
                       crc1 = CRC16(3+qtde);
                    } else
                     {
                       frame[2]=qtde*2; for (i=0;i<qtde;i++) { value = analogarray[address+i]; frame[j] = value >> 8; j=j+1; frame[j] = value & 0xFF; j=j+1; }
                       crc1 = CRC16(3+qtde*2); 
                     }  
                    frame[j] = crc1 >> 8; j=j+1; frame[j] = crc1 & 0xFF; j=j+1;
                    Serial.write(frame,j);
                  } else
                  if (((function >= 5)&&(function <= 6)) || (function == 10)) {
                    if (function == 5)  {
                     if (value>0) { digitalarray[address] = 1; } else { digitalarray[address] = 0; }
                     if (outputdigital==true) { digitalWrite(address+i,digitalarray[address]); }
                     Serial.write(frame,8);
                    } else
                    if (function==6) {
                      analogarray[address] = value; Serial.write(frame,8);
                     } else 
                     if (function==16) {
                      j=7;
                      for (i=0;i<qtde;i++) {  analogarray[address+i] = frame[j]*256+frame[j+1]; j=j+2;   }
                      j=6;
                      crccalculated = CRC16(6); frame[j]=crccalculated >> 8; frame[j+1]=crccalculated & 0xFF;
                      Serial.write(frame,8);
                      }
                  }
                 }
        }
}

unsigned int CRC16(byte size1) 
{
  unsigned int x1, x, e;
  x = 0xFFFF; for (byte i=0;i<size1;i++) { x=x ^ frame[i]; for (byte j=1;j<=8;j++) { e=x & 0x0001; x >>= 1; if (e) {x ^= 0xA001;} } }
  x1 = x>>8; x=(x<<8) | x1; x &= 0xFFFF;
  return x;
}
